"use strict";
var src_1 = require('../../../../src');
function run() {
    describe("TapClick", function () {
        describe("isActivatable", function () {
            it('should be activatable on <a> element', function () {
                var ele = document.createElement('a');
                expect(src_1.isActivatable(ele)).toBe(true);
            });
            it('should be activatable on <button> element', function () {
                var ele = document.createElement('button');
                expect(src_1.isActivatable(ele)).toBe(true);
            });
            it('should be activatable on <ion-item-sliding> element', function () {
                var ele = document.createElement('ion-item-sliding');
                expect(src_1.isActivatable(ele)).toBe(false);
            });
            it('should be not activatable on <ion-item> element', function () {
                var ele = document.createElement('ion-item');
                expect(src_1.isActivatable(ele)).toBe(false);
            });
            it('should be not activatable on <div> element', function () {
                var ele = document.createElement('div');
                expect(src_1.isActivatable(ele)).toBe(false);
            });
            it('should be activatable with "tappable" attribute', function () {
                var ele = document.createElement('div');
                ele.setAttribute('tappable', 'true');
                expect(src_1.isActivatable(ele)).toBe(true);
            });
        });
    });
}
exports.run = run;